unit porttest;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, PieImage, ExtCtrls, MyCom, MMSystem, Buttons;

const    mmtimerpriority=256;
         mmtimerdelay=1;
         mmtimerresolution=0;
function Inp32 (PortAddress:smallint):shortint; stdcall;
function Out32 (PortAddress:smallint; Value:shortint):shortint; stdcall;
procedure switchleds;
procedure TimeCallBack(TimerID, Msg: Uint; dwUser, dw1, dw2: DWORD); pascal;

type
    TLARGE_INTEGER = record

                        LowPart:  Longint;
                        HighPart: Longint;

                     end;

    {PLargeInteger = ^TLargeInteger;}

    TForm1 = class(TForm)
    Bled2: TButton;
    Bled7: TButton;
    Bled6: TButton;
    Bled5: TButton;
    Bled4: TButton;
    Bled3: TButton;
    Bled1: TButton;
    Bled0: TButton;
    TimerB: TButton;
    TrackBar1: TTrackBar;
    LabelT: TLabel;
    Pled7off: TPieImage;
    Pled6off: TPieImage;
    Pled5off: TPieImage;
    Pled4off: TPieImage;
    Pled3off: TPieImage;
    Pled2off: TPieImage;
    Pled1off: TPieImage;
    Pled0off: TPieImage;
    Pled0on: TPieImage;
    Pled6on: TPieImage;
    Pled5on: TPieImage;
    Pled4on: TPieImage;
    Pled1on: TPieImage;
    Pled3on: TPieImage;
    Pled2on: TPieImage;
    Pled7on: TPieImage;
    Timer: TTimer;
    RS232: TComm;
    MMTBtn: TBitBtn;
    LabelR: TLabel;
    MMTLabel: TLabel;
    procedure Bled0Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Bled1Click(Sender: TObject);
    procedure Bled2Click(Sender: TObject);
    procedure Bled3Click(Sender: TObject);
    procedure Bled4Click(Sender: TObject);
    procedure Bled5Click(Sender: TObject);
    procedure Bled6Click(Sender: TObject);
    procedure Bled7Click(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure TimerBClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure RS232ComError(Sender: TObject; ECode: Integer);
    procedure MMTBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);





  private
    { Private-Deklarationen }

  public
   { Public-Deklarationen }


end;
const pbaseadr=$378;
      pxecpadr=pbaseadr+$402;
var
  Form1: TForm1;
  Datenbyte:shortint;
  Result:shortint;
  mmResult:integer; {Multimediatimer-Variable}
  defaultpriority:integer;
  hrRes, hrT1, hrT2, dif, hrMMT1, hrMMT2, MMTdif: TLargeInteger;
  TimeStampAvailable: boolean;
  MMTcount:integer;
  MMTenabled:boolean;

implementation

{$R *.DFM}


Function Inp32 (PortAddress:smallint):shortint; stdcall;
external  'inpout32.dll';
function Out32 (PortAddress:smallint; Value:shortint):shortint; stdcall;
external  'inpout32.dll'



procedure TForm1.Bled0Click(Sender: TObject);
begin
if Bled0.tag =0 then
 begin
 Bled0.tag:=1;
 Pled0off.visible:=false;
 Pled0on.visible:=true;
 Datenbyte:=Datenbyte or $1;

 end else
 begin
 Bled0.tag:=0;
 Pled0on.visible:=false;
 Pled0off.visible:=true;
 Datenbyte:=Datenbyte xor $1;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
TimeStampAvailable:=false;
Datenbyte:=0;
out32(pbaseadr,datenbyte);
if QueryPerformanceFrequency(hrRes) then TimeStampAvailable:=true;
{$IFDEF WIN32}
defaultpriority:=GetPriorityClass(GetCurrentProcess());
{$ENDIF}
end;

procedure TForm1.Bled1Click(Sender: TObject);
begin
if Bled1.tag =0 then
 begin
 Bled1.tag:=1;
 Pled1off.visible:=false;
 Pled1on.visible:=true;
 Datenbyte:=Datenbyte or $2;

 end else
 begin
 Bled1.tag:=0;
 Pled1on.visible:=false;
 Pled1off.visible:=true;
 Datenbyte:=Datenbyte xor $2;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);
end;

procedure TForm1.Bled2Click(Sender: TObject);
begin
if Bled2.tag =0 then
 begin
 Bled2.tag:=1;
 Pled2off.visible:=false;
 Pled2on.visible:=true;
 Datenbyte:=Datenbyte or $4;

 end else
 begin
 Bled2.tag:=0;
 Pled2on.visible:=false;
 Pled2off.visible:=true;
 Datenbyte:=Datenbyte xor $4;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);
end;

procedure TForm1.Bled3Click(Sender: TObject);
begin
if Bled3.tag =0 then
 begin
 Bled3.tag:=1;
 Pled3off.visible:=false;
 Pled3on.visible:=true;
 Datenbyte:=Datenbyte or $8;

 end else
 begin
 Bled3.tag:=0;
 Pled3on.visible:=false;
 Pled3off.visible:=true;
 Datenbyte:=Datenbyte xor $8;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);
end;

procedure TForm1.Bled4Click(Sender: TObject);
begin
if Bled4.tag =0 then
 begin
 Bled4.tag:=1;
 Pled4off.visible:=false;
 Pled4on.visible:=true;
 Datenbyte:=Datenbyte or $10;

 end else
 begin
 Bled4.tag:=0;
 Pled4on.visible:=false;
 Pled4off.visible:=true;
 Datenbyte:=Datenbyte xor $10;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);
end;

procedure TForm1.Bled5Click(Sender: TObject);
begin
if Bled5.tag =0 then
 begin
 Bled5.tag:=1;
 Pled5off.visible:=false;
 Pled5on.visible:=true;
 Datenbyte:=Datenbyte or $20;

 end else
 begin
 Bled5.tag:=0;
 Pled5on.visible:=false;
 Pled5off.visible:=true;
 Datenbyte:=Datenbyte xor $20;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);
end;

procedure TForm1.Bled6Click(Sender: TObject);
begin
if Bled6.tag =0 then
 begin
 Bled6.tag:=1;
 Pled6off.visible:=false;
 Pled6on.visible:=true;
 Datenbyte:=Datenbyte or $40;

 end else
 begin
 Bled6.tag:=0;
 Pled6on.visible:=false;
 Pled6off.visible:=true;
 Datenbyte:=Datenbyte xor $40;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);
end;

procedure TForm1.Bled7Click(Sender: TObject);
begin
if Bled7.tag =0 then
 begin
 Bled7.tag:=1;
 Pled7off.visible:=false;
 Pled7on.visible:=true;
 Datenbyte:=Datenbyte or $80;

 end else
 begin
 Bled7.tag:=0;
 Pled7on.visible:=false;
 Pled7off.visible:=true;
 Datenbyte:=Datenbyte xor $80;
 end;
 out32(pbaseadr,datenbyte);
 form1.caption:=inttostr(datenbyte);
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
 switchleds; 
 out32(pbaseadr,datenbyte);
 if TimeStampAvailable then
 begin
 QueryPerformanceCounter(hrMMT2);
 MMTdif.lowpart := hrMMT2.lowpart - hrMMT1.lowpart;
 MMTdif.highpart:= hrMMT2.highpart - hrMMT1.highpart;
 QueryPerformanceCounter(hrMMT1);
 if MMTdif.highpart=0 then
  labelR.caption:= floattostrF((MMTdif.lowpart / hrRes.lowpart*1000),ffFixed,9,3)+'ms';
 end;

end;

procedure switchleds;
begin
with form1 do
 begin
 if Bled0.tag =0 then
 begin
 Bled0.tag:=1;
 Pled0off.visible:=false;
 Pled0on.visible:=true;
 Datenbyte:=Datenbyte or $1;

 end else
 begin
 Bled0.tag:=0;
 Pled0on.visible:=false;
 Pled0off.visible:=true;
 Datenbyte:=Datenbyte xor $1;
 end;

 if Bled1.tag =0 then
 begin
 Bled1.tag:=1;
 Pled1off.visible:=false;
 Pled1on.visible:=true;
 Datenbyte:=Datenbyte or $2;

 end else
 begin
 Bled1.tag:=0;
 Pled1on.visible:=false;
 Pled1off.visible:=true;
 Datenbyte:=Datenbyte xor $2;
 end;

 if Bled2.tag =0 then
 begin
 Bled2.tag:=1;
 Pled2off.visible:=false;
 Pled2on.visible:=true;
 Datenbyte:=Datenbyte or $4;

 end else
 begin
 Bled2.tag:=0;
 Pled2on.visible:=false;
 Pled2off.visible:=true;
 Datenbyte:=Datenbyte xor $4;
 end;

 if Bled3.tag =0 then
 begin
 Bled3.tag:=1;
 Pled3off.visible:=false;
 Pled3on.visible:=true;
 Datenbyte:=Datenbyte or $8;

 end else
 begin
 Bled3.tag:=0;
 Pled3on.visible:=false;
 Pled3off.visible:=true;
 Datenbyte:=Datenbyte xor $8;
 end;

 if Bled4.tag =0 then
 begin
 Bled4.tag:=1;
 Pled4off.visible:=false;
 Pled4on.visible:=true;
 Datenbyte:=Datenbyte or $10;

 end else
 begin
 Bled4.tag:=0;
 Pled4on.visible:=false;
 Pled4off.visible:=true;
 Datenbyte:=Datenbyte xor $10;
 end;

 if Bled5.tag =0 then
 begin
 Bled5.tag:=1;
 Pled5off.visible:=false;
 Pled5on.visible:=true;
 Datenbyte:=Datenbyte or $20;

 end else
 begin
 Bled5.tag:=0;
 Pled5on.visible:=false;
 Pled5off.visible:=true;
 Datenbyte:=Datenbyte xor $20;
 end;

 if Bled6.tag =0 then
 begin
 Bled6.tag:=1;
 Pled6off.visible:=false;
 Pled6on.visible:=true;
 Datenbyte:=Datenbyte or $40;

 end else
 begin
 Bled6.tag:=0;
 Pled6on.visible:=false;
 Pled6off.visible:=true;
 Datenbyte:=Datenbyte xor $40;
 end;

 if Bled7.tag =0 then
 begin
 Bled7.tag:=1;
 Pled7off.visible:=false;
 Pled7on.visible:=true;
 Datenbyte:=Datenbyte or $80;

 end else
 begin
 Bled7.tag:=0;
 Pled7on.visible:=false;
 Pled7off.visible:=true;
 Datenbyte:=Datenbyte xor $80;
 end;
end;

end;

procedure TForm1.TimerBClick(Sender: TObject);
begin
if  TimerB.tag =0 then
  begin
  TimerB.tag:=1;
  labelT.caption:='Timer '+inttostr(trackbar1.position)+' ms';
  Timer.enabled:=true;
  if TimeStampAvailable then QueryPerformanceCounter(hrMMT1);
  end else
  begin
  TimerB.tag:=0;
  LabelT.caption:='Timer disabled';
  Timer.enabled:=false;
  end;



end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
timer.interval:=trackbar1.position;
if timerb.tag=1 then
   labelT.caption:='Timer '+inttostr(trackbar1.position)+' ms';
end;

procedure TForm1.RS232ComError(Sender: TObject; ECode: Integer);
begin
form1.caption:='RS232 Error';
end;



procedure TForm1.MMTBtnClick(Sender: TObject);

begin

if MMTBtn.tag=0 then
 begin
 MMTBtn.tag:=1;
 MMTLabel.caption:='MMT enabled';
 MMTCount:=0;
 {$IFDEF WIN32}
  SetPriorityClass(GetCurrentProcess(),mmtimerpriority);
  form1.caption:='Priority '+inttostr(mmtimerpriority);
 {$ENDIF}
 if TimeStampAvailable then QueryPerformanceCounter(hrMMT1);
 mmResult := TimeSetEvent(mmtimerdelay, mmtimerresolution, @TimeCallBack, 0, TIME_PERIODIC)
 end else
 begin
 TimeKillEvent(mmResult);
 if TimeStampAvailable then QueryPerformanceCounter(hrMMT2);
 MMTBtn.tag:=0;
 MMTLabel.caption:='MMT disabled';
 {$IFDEF WIN32}
 SetPriorityClass(GetCurrentProcess(),defaultpriority);
 form1.caption:='Priority '+inttostr(defaultpriority);
 {$ENDIF}
 switchleds;
 if TimeStampAvailable then
 begin
 MMTdif.lowpart := hrMMT2.lowpart - hrMMT1.lowpart;
 MMTdif.highpart:= hrMMT2.highpart - hrMMT1.highpart;
 if MMTdif.highpart=0 then
  labelR.caption:= floattostrF(abs(MMTdif.lowpart / hrRes.lowpart/MMTcount*1000),ffFixed,9,3)+'ms, ResH '+inttostr(hrRes.highpart)+' ResL'+inttostr(hrRes.lowpart);
 end;

 end;
end;

procedure TimeCallBack(TimerID, Msg: Uint; dwUser, dw1, dw2: DWORD); pascal;
begin
  {switchleds; }                {disabled im High-Performance Mode}
  datenbyte:= not datenbyte;    {umschalten}
  out32(pbaseadr,datenbyte);
  inc (MMTCount);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
if form1.MMTBtn.tag=1 then TimeKillEvent(mmResult);
if timer.enabled then timer.enabled:=false;
out32(pbaseadr,0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if form1.MMTBtn.tag=1 then TimeKillEvent(mmResult);
if timer.enabled then timer.enabled:=false;
out32(pbaseadr,0);
end;

end.


{==========================================================================

2 microsecunden delay:
procedure PerformanceDelay;
var
  hrRes, hrT1, hrT2, dif: Int64;
begin
  if QueryPerformanceFrequency(hrRes) then
  begin
    QueryPerformanceCounter(hrT1);
    repeat
      QueryPerformanceCounter(hrT2);
      dif := (hrT2 - hrT1) * 10000000 div hrRes;
    until dif > 2;
  end;
end;


Multimedia-Timer


  The timeSetEvent function starts a specified timer event.
  The multimedia timer runs in its own thread. After the event is activated,
  it calls the specified callback function or sets or pulses the specified event object.

  MMRESULT timeSetEvent(
  UINT           uDelay,
  UINT           uResolution,
  LPTIMECALLBACK lpTimeProc,
  DWORD_PTR      dwUser,
  UINT           fuEvent
  );

  uDelay:
   Event delay, in milliseconds

  uResolution:
   Resolution of the timer event, in milliseconds.
   A resolution of 0 indicates periodic events should occur with the
   greatest possible accuracy.
   You should use the use the maximum value appropriate to reduce system overhead.

  fuEvent:
   TIME_ONESHOT Event occurs once, after uDelay milliseconds.
   TIME_PERIODIC Event occurs every uDelay milliseconds.
}




